Loading...
Searching...
No Matches
pcl::ApproximateProgressiveMorphologicalFilter< PointT > Class Template Reference

Implements the Progressive Morphological Filter for segmentation of ground points. More...

`#include <pcl/segmentation/approximate_progressive_morphological_filter.h>`

Inheritance diagram for pcl::ApproximateProgressiveMorphologicalFilter< PointT >:

## Public Types

using | PointCloud = pcl::PointCloud< PointT >
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| ApproximateProgressiveMorphologicalFilter ()
| Constructor that sets default values for member variables.
| ~ApproximateProgressiveMorphologicalFilter () override
int | getMaxWindowSize () const
| Get the maximum window size to be used in filtering ground returns.
void | setMaxWindowSize (int max_window_size)
| Set the maximum window size to be used in filtering ground returns.
float | getSlope () const
| Get the slope value to be used in computing the height threshold.
void | setSlope (float slope)
| Set the slope value to be used in computing the height threshold.
float | getMaxDistance () const
| Get the maximum height above the parameterized ground surface to be considered a ground return.
void | setMaxDistance (float max_distance)
| Set the maximum height above the parameterized ground surface to be considered a ground return.
float | getInitialDistance () const
| Get the initial height above the parameterized ground surface to be considered a ground return.
void | setInitialDistance (float initial_distance)
| Set the initial height above the parameterized ground surface to be considered a ground return.
float | getCellSize () const
| Get the cell size.
void | setCellSize (float cell_size)
| Set the cell size.
float | getBase () const
| Get the base to be used in computing progressive window sizes.
void | setBase (float base)
| Set the base to be used in computing progressive window sizes.
bool | getExponential () const
| Get flag indicating whether or not to exponentially grow window sizes?
void | setExponential (bool exponential)
| Set flag indicating whether or not to exponentially grow window sizes?
void | setNumberOfThreads (unsigned int nr_threads=0)
| Initialize the scheduler and set the number of threads to use.
virtual void | extract (Indices &ground)
| This method launches the segmentation algorithm and returns indices of points determined to be ground returns.
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Attributes

int | max_window_size_ {33}
| Maximum window size to be used in filtering ground returns.
float | slope_ {0.7f}
| Slope value to be used in computing the height threshold.
float | max_distance_ {10.0f}
| Maximum height above the parameterized ground surface to be considered a ground return.
float | initial_distance_ {0.15f}
| Initial height above the parameterized ground surface to be considered a ground return.
float | cell_size_ {1.0f}
| Cell size.
float | base_ {2.0f}
| Base to be used in computing progressive window sizes.
bool | exponential_ {true}
| Exponentially grow window sizes?
unsigned int | threads_ {0}
| Number of threads to be used.
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Additional Inherited Members

Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Detailed Description

template<typename PointT>
class pcl::ApproximateProgressiveMorphologicalFilter< PointT >

Implements the Progressive Morphological Filter for segmentation of ground points.

Description can be found in the article "A Progressive Morphological Filter for Removing Nonground Measurements from Airborne LIDAR Data" by K. Zhang, S. Chen, D. Whitman, M. Shyu, J. Yan, and C. Zhang.

Definition at line 56 of file approximate_progressive_morphological_filter.h.

## Member Typedef Documentation

## PointCloud

template<typename PointT >

using pcl::ApproximateProgressiveMorphologicalFilter< PointT >::PointCloud = pcl::PointCloud<PointT>

Definition at line 60 of file approximate_progressive_morphological_filter.h.

## Constructor & Destructor Documentation

## ApproximateProgressiveMorphologicalFilter()

template<typename PointT >

pcl::ApproximateProgressiveMorphologicalFilter< PointT >::ApproximateProgressiveMorphologicalFilter | ( |  | ) |

default

Constructor that sets default values for member variables.

## ~ApproximateProgressiveMorphologicalFilter()

template<typename PointT >

pcl::ApproximateProgressiveMorphologicalFilter< PointT >::~ApproximateProgressiveMorphologicalFilter | ( |  | ) |

override default

## Member Function Documentation

## extract()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::extract | ( | Indices & | ground | ) |

virtual

This method launches the segmentation algorithm and returns indices of points determined to be ground returns.

Parameters

  [out] | ground | indices of points determined to be ground returns.

Definition at line 60 of file approximate_progressive_morphological_filter.hpp.

References pcl::isFinite().

## getBase()

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getBase | ( |  | ) | const

inline

Get the base to be used in computing progressive window sizes.

Definition at line 117 of file approximate_progressive_morphological_filter.h.

## getCellSize()

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getCellSize | ( |  | ) | const

inline

Get the cell size.

Definition at line 109 of file approximate_progressive_morphological_filter.h.

## getExponential()

template<typename PointT >

bool pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getExponential | ( |  | ) | const

inline

Get flag indicating whether or not to exponentially grow window sizes?

Definition at line 125 of file approximate_progressive_morphological_filter.h.

## getInitialDistance()

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getInitialDistance | ( |  | ) | const

inline

Get the initial height above the parameterized ground surface to be considered a ground return.

Definition at line 101 of file approximate_progressive_morphological_filter.h.

## getMaxDistance()

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getMaxDistance | ( |  | ) | const

inline

Get the maximum height above the parameterized ground surface to be considered a ground return.

Definition at line 93 of file approximate_progressive_morphological_filter.h.

## getMaxWindowSize()

template<typename PointT >

int pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getMaxWindowSize | ( |  | ) | const

inline

Get the maximum window size to be used in filtering ground returns.

Definition at line 77 of file approximate_progressive_morphological_filter.h.

## getSlope()

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getSlope | ( |  | ) | const

inline

Get the slope value to be used in computing the height threshold.

Definition at line 85 of file approximate_progressive_morphological_filter.h.

## setBase()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setBase | ( | float | base | ) |

inline

Set the base to be used in computing progressive window sizes.

Definition at line 121 of file approximate_progressive_morphological_filter.h.

## setCellSize()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setCellSize | ( | float | cell_size | ) |

inline

Set the cell size.

Definition at line 113 of file approximate_progressive_morphological_filter.h.

## setExponential()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setExponential | ( | bool | exponential | ) |

inline

Set flag indicating whether or not to exponentially grow window sizes?

Definition at line 129 of file approximate_progressive_morphological_filter.h.

## setInitialDistance()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setInitialDistance | ( | float | initial_distance | ) |

inline

Set the initial height above the parameterized ground surface to be considered a ground return.

Definition at line 105 of file approximate_progressive_morphological_filter.h.

## setMaxDistance()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setMaxDistance | ( | float | max_distance | ) |

inline

Set the maximum height above the parameterized ground surface to be considered a ground return.

Definition at line 97 of file approximate_progressive_morphological_filter.h.

## setMaxWindowSize()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setMaxWindowSize | ( | int | max_window_size | ) |

inline

Set the maximum window size to be used in filtering ground returns.

Definition at line 81 of file approximate_progressive_morphological_filter.h.

## setNumberOfThreads()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setNumberOfThreads | ( | unsigned int | nr_threads = `0` | ) |

inline

Initialize the scheduler and set the number of threads to use.

Parameters

  nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 135 of file approximate_progressive_morphological_filter.h.

## setSlope()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setSlope | ( | float | slope | ) |

inline

Set the slope value to be used in computing the height threshold.

Definition at line 89 of file approximate_progressive_morphological_filter.h.

## Member Data Documentation

## base_

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::base_ {2.0f}

protected

Base to be used in computing progressive window sizes.

Definition at line 162 of file approximate_progressive_morphological_filter.h.

## cell_size_

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::cell_size_ {1.0f}

protected

Cell size.

Definition at line 159 of file approximate_progressive_morphological_filter.h.

## exponential_

template<typename PointT >

bool pcl::ApproximateProgressiveMorphologicalFilter< PointT >::exponential_ {true}

protected

Exponentially grow window sizes?

Definition at line 165 of file approximate_progressive_morphological_filter.h.

## initial_distance_

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::initial_distance_ {0.15f}

protected

Initial height above the parameterized ground surface to be considered a ground return.

Definition at line 156 of file approximate_progressive_morphological_filter.h.

## max_distance_

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::max_distance_ {10.0f}

protected

Maximum height above the parameterized ground surface to be considered a ground return.

Definition at line 153 of file approximate_progressive_morphological_filter.h.

## max_window_size_

template<typename PointT >

int pcl::ApproximateProgressiveMorphologicalFilter< PointT >::max_window_size_ {33}

protected

Maximum window size to be used in filtering ground returns.

Definition at line 147 of file approximate_progressive_morphological_filter.h.

## slope_

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::slope_ {0.7f}

protected

Slope value to be used in computing the height threshold.

Definition at line 150 of file approximate_progressive_morphological_filter.h.

## threads_

template<typename PointT >

unsigned int pcl::ApproximateProgressiveMorphologicalFilter< PointT >::threads_ {0}

protected

Number of threads to be used.

Definition at line 168 of file approximate_progressive_morphological_filter.h.

The documentation for this class was generated from the following files:

- pcl/segmentation/approximate_progressive_morphological_filter.h
- pcl/segmentation/impl/approximate_progressive_morphological_filter.hpp